[Top] | [Contents] | [Index] | [ ? ]

# Libavfilter Documentation

# 1. Introduction

Libavfilter is the filtering API of Libav. It replaces 'vhooks', and started as a Google Summer of Code project.

Note that there may still be serious bugs in the code and its API and ABI should not be considered stable yet!

# 2. Tutorial

In libavfilter, it is possible for filters to have multiple inputs and multiple outputs. To illustrate the sorts of things that are possible, we can use a complex filter graph. For example, the following one:

    input --> split --> fifo -----------------------> overlay --> output
                |                                        ^
                |                                        |
                +------> fifo --> crop --> vflip --------+

splits the stream in two streams, then sends one stream through the crop filter and the vflip filter, before merging it back with the other stream by overlaying it on top. You can use the following command to achieve this:

    ./avconv -i input -vf "[in] split [T1], fifo, [T2] overlay=0:H/2 [out]; [T1] fifo, crop=iw:ih/2:0:ih/2, vflip [T2]" output

The result will be that the top half of the video is mirrored onto the bottom half of the output video.

Video filters are loaded using the -vf option passed to avconv or to avplay. Filters in the same linear chain are separated by commas. In our example, split, fifo, and overlay are in one linear chain, and fifo, crop, and vflip are in another. The points where the linear chains join are labeled by names enclosed in square brackets. In our example, they join at [T1] and [T2]. The magic labels [in] and [out] are the points where video is input and output.

Some filters take a list of parameters: they are specified after the filter name and an equal sign, and are separated by a semicolon.

There are so-called source filters that do not take video input, and we expect that some sink filters will not have video output, at some point in the future.

# 3. graph2dot

The ``graph2dot'` program included in the Libav ``tools'` directory can be used to parse a filter graph description and issue a corresponding textual representation in the dot language.

Invoke the command:

    graph2dot -h

to see how to use ``graph2dot'`.

You can then pass the dot description to the ``dot'` program (from the graphviz suite of programs) and obtain a graphical representation of the filter graph.

For example the sequence of commands:

    echo GRAPH_DESCRIPTION | \
    tools/graph2dot -o graph.tmp && \
    dot -Tpng graph.tmp -o graph.png && \
    display graph.png

can be used to create and display an image representing the graph described by the GRAPH_DESCRIPTION string.

# 4. Filtergraph description

A filtergraph is a directed graph of connected filters. It can contain cycles, and there can be multiple links between a pair of filters. Each link has one input pad on one side connecting it to one filter from which it takes its input, and one output pad on the other side connecting it to one filter accepting its output.

Each filter in a filtergraph is an instance of a filter class registered in the application, which defines the features and the number of input and output pads of the filter.

A filter with no input pads is called a "source", and a filter with no output pads is called a "sink".

## 4.1 Filtergraph syntax

A filtergraph has a textual representation, which is recognized by the ``-filter'`/``-vf'` and ``-filter_complex'` options in `avconv` and ``-vf'` in `avplay`, and by the `avfilter_graph_parse()`/`avfilter_graph_parse2()` functions defined in ``libavfilter/avfilter.h'`.

A filterchain consists of a sequence of connected filters, each one connected to the previous one in the sequence. A filterchain is represented by a list of ","-separated filter descriptions.

A filtergraph consists of a sequence of filterchains. A sequence of filterchains is represented by a list of ";"-separated filterchain descriptions.

A filter is represented by a string of the form: [in_link_1]...[in_link_N]filter_name=arguments[out_link_1]...[out_link_M]

filter_name is the name of the filter class of which the described filter is an instance of, and has to be the name of one of the filter classes registered in the program. The name of the filter class is optionally followed by a string "=arguments".

arguments is a string which contains the parameters used to initialize the filter instance. It may have one of two forms:

If the option value itself is a list of items (e.g. the `format` filter takes a list of pixel formats), the items in the list are usually separated by '|'.

The list of arguments can be quoted using the character "'" as initial and ending mark, and the character '\' for escaping the characters within the quoted text; otherwise the argument string is considered terminated when the next special character (belonging to the set "[]=;,") is encountered.

The name and arguments of the filter are optionally preceded and followed by a list of link labels. A link label allows to name a link and associate it to a filter output or input pad. The preceding labels in_link_1 ... in_link_N, are associated to the filter input pads, the following labels out_link_1 ... out_link_M, are associated to the output pads.

When two link labels with the same name are found in the filtergraph, a link between the corresponding input and output pad is created.

If an output pad is not labelled, it is linked by default to the first unlabelled input pad of the next filter in the filterchain. For example in the filterchain

    nullsrc, split[L1], [L2]overlay, nullsink

the split filter instance has two output pads, and the overlay filter instance two input pads. The first output pad of split is labelled "L1", the first input pad of overlay is labelled "L2", and the second output pad of split is linked to the second input pad of overlay, which are both unlabelled.

In a complete filterchain all the unlabelled filter input and output pads must be connected. A filtergraph is considered valid if all the filter input and output pads of all the filterchains are connected.

Libavfilter will automatically insert scale filters where format conversion is required. It is possible to specify swscale flags for those automatically inserted scalers by prepending `sws_flags=flags;` to the filtergraph description.

Here is a BNF description of the filtergraph syntax:

    NAME             ::= sequence of alphanumeric characters and '_'
    LINKLABEL        ::= "[" NAME "]"
    LINKLABELS       ::= LINKLABEL [LINKLABELS]
    FILTER_ARGUMENTS ::= sequence of chars (possibly quoted)
    FILTER           ::= [LINKLABELS] NAME ["=" FILTER_ARGUMENTS] [LINKLABELS]
    FILTERCHAIN      ::= FILTER [,FILTERCHAIN]
    FILTERGRAPH      ::= [sws_flags=flags;] FILTERCHAIN [;FILTERGRAPH]

# 5. Audio Filters

When you configure your Libav build, you can disable any of the existing filters using -disable-filters. The configure output will show the audio filters included in your build.

Below is a description of the currently available audio filters.

## 5.1 aformat

Convert the input audio to one of the specified formats. The framework will negotiate the most appropriate format to minimize conversions.

It accepts the following parameters:

``sample_fmts'`

  A '|'-separated list of requested sample formats.

``sample_rates'`

  A '|'-separated list of requested sample rates.

``channel_layouts'`

  A '|'-separated list of requested channel layouts.

If a parameter is omitted, all values are allowed.

Force the output to either unsigned 8-bit or signed 16-bit stereo

    aformat=sample_fmts=u8|s16:channel_layouts=stereo

## 5.2 amix

Mixes multiple audio inputs into a single output.

For example

    avconv -i INPUT1 -i INPUT2 -i INPUT3 -filter_complex amix=inputs=3:duration=first:dropout_transition=3 OUTPUT

will mix 3 input audio streams to a single output with the same duration as the first input and a dropout transition time of 3 seconds.

It accepts the following parameters:

``inputs'`

  The number of inputs. If unspecified, it defaults to 2.

``duration'`

  How to determine the end-of-stream.

  ``longest'`

    The duration of the longest input. (default)

  ``shortest'`

    The duration of the shortest input.

  ``first'`

    The duration of the first input.

``dropout_transition'`

  The transition time, in seconds, for volume renormalization when an input stream ends. The default value is 2 seconds.

## 5.3 anull

Pass the audio source unchanged to the output.

## 5.4 asetpts

Change the PTS (presentation timestamp) of the input audio frames.

It accepts the following parameters:

``expr'`

  The expression which is evaluated for each frame to construct its timestamp.

The expression is evaluated through the eval API and can contain the following constants:

``PTS'`

  the presentation timestamp in input

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``N'`

  The number of audio samples passed through the filter so far, starting at 0.

``S'`

  The number of audio samples in the current frame.

``SR'`

  The audio sample rate.

``STARTPTS'`

  The PTS of the first frame.

``PREV_INPTS'`

  The previous input PTS.

``PREV_OUTPTS'`

  The previous output PTS.

``RTCTIME'`

  The wallclock (RTC) time in microseconds.

``RTCSTART'`

  The wallclock (RTC) time at the start of the movie in microseconds.

Some examples:

    # Start counting PTS from zero
    asetpts=expr=PTS-STARTPTS

    # Generate timestamps by counting samples
    asetpts=expr=N/SR/TB

    # Generate timestamps from a "live source" and rebase onto the current timebase
    asetpts='(RTCTIME - RTCSTART) / (TB * 1000000)"

## 5.5 asettb

Set the timebase to use for the output frames timestamps. It is mainly useful for testing timebase configuration.

This filter accepts the following parameters:

``expr'`

  The expression which is evaluated into the output timebase.

The expression can contain the constants PI, E, PHI, AVTB (the default timebase), intb (the input timebase), and sr (the sample rate, audio only).

The default value for the input is intb.

Some examples:

    # Set the timebase to 1/25:
    settb=1/25

    # Set the timebase to 1/10:
    settb=0.1

    # Set the timebase to 1001/1000:
    settb=1+0.001

    # Set the timebase to 2*intb:
    settb=2*intb

    # Set the default timebase value:
    settb=AVTB

    # Set the timebase to twice the sample rate:
    asettb=sr*2

## 5.6 ashowinfo

Show a line containing various information for each input audio frame. The input audio is not modified.

The shown line contains a sequence of key/value pairs of the form key:value.

It accepts the following parameters:

``n'`

  The (sequential) number of the input frame, starting from 0.

``pts'`

  The presentation timestamp of the input frame, in time base units; the time base depends on the filter input pad, and is usually 1/sample_rate.

``pts_time'`

  The presentation timestamp of the input frame in seconds.

``fmt'`

  The sample format.

``chlayout'`

  The channel layout.

``rate'`

  The sample rate for the audio frame.

``nb_samples'`

  The number of samples (per channel) in the frame.

``checksum'`

  The Adler-32 checksum (printed in hexadecimal) of the audio data. For planar audio, the data is treated as if all the planes were concatenated.

``plane_checksums'`

  A list of Adler-32 checksums for each data plane.

## 5.7 asplit

Split input audio into several identical outputs.

It accepts a single parameter, which specifies the number of outputs. If unspecified, it defaults to 2.

For example,

    avconv -i INPUT -filter_complex asplit=5 OUTPUT

will create 5 copies of the input audio.

## 5.8 asyncts

Synchronize audio data with timestamps by squeezing/stretching it and/or dropping samples/adding silence when needed.

It accepts the following parameters:

``compensate'`

  Enable stretching/squeezing the data to make it match the timestamps. Disabled by default. When disabled, time gaps are covered with silence.

``min_delta'`

  The minimum difference between timestamps and audio data (in seconds) to trigger adding/dropping samples. The default value is 0.1. If you get an imperfect sync with this filter, try setting this parameter to 0.

``max_comp'`

  The maximum compensation in samples per second. Only relevant with compensate=1. The default value is 500.

``first_pts'`

  Assume that the first PTS should be this value. The time base is 1 / sample rate. This allows for padding/trimming at the start of the stream. By default, no assumption is made about the first frame's expected PTS, so no padding or trimming is done. For example, this could be set to 0 to pad the beginning with silence if an audio stream starts after the video stream or to trim any samples with a negative PTS due to encoder delay.

## 5.9 atrim

Trim the input so that the output contains one continuous subpart of the input.

It accepts the following parameters:

``start'`

  Timestamp (in seconds) of the start of the section to keep. I.e. the audio sample with the timestamp start will be the first sample in the output.

``end'`

  Timestamp (in seconds) of the first audio sample that will be dropped. I.e. the audio sample immediately preceding the one with the timestamp end will be the last sample in the output.

``start_pts'`

  Same as start, except this option sets the start timestamp in samples instead of seconds.

``end_pts'`

  Same as end, except this option sets the end timestamp in samples instead of seconds.

``duration'`

  The maximum duration of the output in seconds.

``start_sample'`

  The number of the first sample that should be output.

``end_sample'`

  The number of the first sample that should be dropped.

Note that the first two sets of the start/end options and the ``duration'` option look at the frame timestamp, while the _sample options simply count the samples that pass through the filter. So start/end_pts and start/end_sample will give different results when the timestamps are wrong, inexact or do not start at zero. Also note that this filter does not modify the timestamps. If you wish to have the output timestamps start at zero, insert the asetpts filter after the atrim filter.

If multiple start or end options are set, this filter tries to be greedy and keep all samples that match at least one of the specified constraints. To keep only the part that matches all the constraints at once, chain multiple atrim filters.

The defaults are such that all the input is kept. So it is possible to set e.g. just the end values to keep everything before the specified time.

Examples:

## 5.10 bs2b

Bauer stereo to binaural transformation, which improves headphone listening of stereo audio records.

It accepts the following parameters:

``profile'`

  Pre-defined crossfeed level.

  ``default'`

    Default level (fcut=700, feed=50).

  ``cmoy'`

    Chu Moy circuit (fcut=700, feed=60).

  ``jmeier'`

    Jan Meier circuit (fcut=650, feed=95).

``fcut'`

  Cut frequency (in Hz).

``feed'`

  Feed level (in Hz).

## 5.11 channelsplit

Split each channel from an input audio stream into a separate output stream.

It accepts the following parameters:

``channel_layout'`

  The channel layout of the input stream. The default is "stereo".

For example, assuming a stereo input MP3 file,

    avconv -i in.mp3 -filter_complex channelsplit out.mkv

will create an output Matroska file with two audio streams, one containing only the left channel and the other the right channel.

Split a 5.1 WAV file into per-channel files:

    avconv -i in.wav -filter_complex
    'channelsplit=channel_layout=5.1[FL][FR][FC][LFE][SL][SR]'
    -map '[FL]' front_left.wav -map '[FR]' front_right.wav -map '[FC]'
    front_center.wav -map '[LFE]' lfe.wav -map '[SL]' side_left.wav -map '[SR]'
    side_right.wav

## 5.12 channelmap

Remap input channels to new locations.

It accepts the following parameters:

``channel_layout'`

  The channel layout of the output stream.

``map'`

  Map channels from input to output. The argument is a '|'-separated list of mappings, each in the `in_channel-out_channel` or in_channel form. in_channel can be either the name of the input channel (e.g. FL for front left) or its index in the input channel layout. out_channel is the name of the output channel or its index in the output channel layout. If out_channel is not given then it is implicitly an index, starting with zero and increasing by one for each mapping.

If no mapping is present, the filter will implicitly map input channels to output channels, preserving indices.

For example, assuming a 5.1+downmix input MOV file,

    avconv -i in.mov -filter 'channelmap=map=DL-FL|DR-FR' out.wav

will create an output WAV file tagged as stereo from the downmix channels of the input.

To fix a 5.1 WAV improperly encoded in AAC's native channel order

    avconv -i in.wav -filter 'channelmap=1|2|0|5|3|4:channel_layout=5.1' out.wav

## 5.13 compand

Compress or expand the audio's dynamic range.

It accepts the following parameters:

``attacks'`
``decays'`

  A list of times in seconds for each channel over which the instantaneous level of the input signal is averaged to determine its volume. attacks refers to increase of volume and decays refers to decrease of volume. For most situations, the attack time (response to the audio getting louder) should be shorter than the decay time, because the human ear is more sensitive to sudden loud audio than sudden soft audio. A typical value for attack is 0.3 seconds and a typical value for decay is 0.8 seconds.

``points'`

  A list of points for the transfer function, specified in dB relative to the maximum possible signal amplitude. Each key points list must be defined using the following syntax: `x0/y0|x1/y1|x2/y2|....`

  The input values must be in strictly increasing order but the transfer function does not have to be monotonically rising. The point `0/0` is assumed but may be overridden (by `0/out-dBn`). Typical values for the transfer function are `-70/-70|-60/-20`.

``soft-knee'`

  Set the curve radius in dB for all joints. It defaults to 0.01.

``gain'`

  Set the additional gain in dB to be applied at all points on the transfer function. This allows for easy adjustment of the overall gain. It defaults to 0.

``volume'`

  Set an initial volume, in dB, to be assumed for each channel when filtering starts. This permits the user to supply a nominal level initially, so that, for example, a very large gain is not applied to initial signal levels before the companding has begun to operate. A typical value for audio which is initially quiet is -90 dB. It defaults to 0.

``delay'`

  Set a delay, in seconds. The input audio is analyzed immediately, but audio is delayed before being fed to the volume adjuster. Specifying a delay approximately equal to the attack/decay times allows the filter to effectively operate in predictive rather than reactive mode. It defaults to 0.

### 5.13.1 Examples

## 5.14 join

Join multiple input streams into one multi-channel stream.

It accepts the following parameters:

``inputs'`

  The number of input streams. It defaults to 2.

``channel_layout'`

  The desired output channel layout. It defaults to stereo.

``map'`

  Map channels from inputs to output. The argument is a '|'-separated list of mappings, each in the `input_idx.in_channel-out_channel` form. input_idx is the 0-based index of the input stream. in_channel can be either the name of the input channel (e.g. FL for front left) or its index in the specified input stream. out_channel is the name of the output channel.

The filter will attempt to guess the mappings when they are not specified explicitly. It does so by first trying to find an unused matching input channel and if that fails it picks the first unused input channel.

Join 3 inputs (with properly set channel layouts):

    avconv -i INPUT1 -i INPUT2 -i INPUT3 -filter_complex join=inputs=3 OUTPUT

Build a 5.1 output from 6 single-channel streams:

    avconv -i fl -i fr -i fc -i sl -i sr -i lfe -filter_complex
    'join=inputs=6:channel_layout=5.1:map=0.0-FL|1.0-FR|2.0-FC|3.0-SL|4.0-SR|5.0-LFE'
    out

## 5.15 resample

Convert the audio sample format, sample rate and channel layout. It is not meant to be used directly; it is inserted automatically by libavfilter whenever conversion is needed. Use the aformat filter to force a specific conversion.

## 5.16 volume

Adjust the input audio volume.

It accepts the following parameters:

``volume'`

  This expresses how the audio volume will be increased or decreased.

  Output values are clipped to the maximum value.

  The output audio volume is given by the relation:

      output_volume = volume * input_volume

  The default value for volume is 1.0.

``precision'`

  This parameter represents the mathematical precision.

  It determines which input sample formats will be allowed, which affects the precision of the volume scaling.

  ``fixed'`

    8-bit fixed-point; this limits input sample format to U8, S16, and S32.

  ``float'`

    32-bit floating-point; this limits input sample format to FLT. (default)

  ``double'`

    64-bit floating-point; this limits input sample format to DBL.

``replaygain'`

  Choose the behaviour on encountering ReplayGain side data in input frames.

  ``drop'`

    Remove ReplayGain side data, ignoring its contents (the default).

  ``ignore'`

    Ignore ReplayGain side data, but leave it in the frame.

  ``track'`

    Prefer the track gain, if present.

  ``album'`

    Prefer the album gain, if present.

``replaygain_preamp'`

  Pre-amplification gain in dB to apply to the selected replaygain gain.

  Default value for replaygain_preamp is 0.0.

``replaygain_noclip'`

  Prevent clipping by limiting the gain applied.

  Default value for replaygain_noclip is 1.

### 5.16.1 Examples

# 6. Audio Sources

Below is a description of the currently available audio sources.

## 6.1 anullsrc

The null audio source; it never returns audio frames. It is mainly useful as a template and for use in analysis / debugging tools.

It accepts, as an optional parameter, a string of the form sample_rate:channel_layout.

sample_rate specifies the sample rate, and defaults to 44100.

channel_layout specifies the channel layout, and can be either an integer or a string representing a channel layout. The default value of channel_layout is 3, which corresponds to CH_LAYOUT_STEREO.

Check the channel_layout_map definition in ``libavutil/channel_layout.c'` for the mapping between strings and channel layout values.

Some examples:

    # Set the sample rate to 48000 Hz and the channel layout to CH_LAYOUT_MONO
    anullsrc=48000:4

    # The same as above
    anullsrc=48000:mono

## 6.2 abuffer

Buffer audio frames, and make them available to the filter chain.

This source is not intended to be part of user-supplied graph descriptions; it is for insertion by calling programs, through the interface defined in ``libavfilter/buffersrc.h'`.

It accepts the following parameters:

``time_base'`

  The timebase which will be used for timestamps of submitted frames. It must be either a floating-point number or in numerator/denominator form.

``sample_rate'`

  The audio sample rate.

``sample_fmt'`

  The name of the sample format, as returned by `av_get_sample_fmt_name()`.

``channel_layout'`

  The channel layout of the audio data, in the form that can be accepted by `av_get_channel_layout()`.

All the parameters need to be explicitly defined.

# 7. Audio Sinks

Below is a description of the currently available audio sinks.

## 7.1 anullsink

Null audio sink; do absolutely nothing with the input audio. It is mainly useful as a template and for use in analysis / debugging tools.

## 7.2 abuffersink

This sink is intended for programmatic use. Frames that arrive on this sink can be retrieved by the calling program, using the interface defined in ``libavfilter/buffersink.h'`.

It does not accept any parameters.

# 8. Video Filters

When you configure your Libav build, you can disable any of the existing filters using -disable-filters. The configure output will show the video filters included in your build.

Below is a description of the currently available video filters.

## 8.1 blackframe

Detect frames that are (almost) completely black. Can be useful to detect chapter transitions or commercials. Output lines consist of the frame number of the detected frame, the percentage of blackness, the position in the file if known or -1 and the timestamp in seconds.

In order to display the output lines, you need to set the loglevel at least to the AV_LOG_INFO value.

It accepts the following parameters:

``amount'`

  The percentage of the pixels that have to be below the threshold; it defaults to 98.

``threshold'`

  The threshold below which a pixel value is considered black; it defaults to 32.

## 8.2 boxblur

Apply a boxblur algorithm to the input video.

It accepts the following parameters:

``luma_radius'`
``luma_power'`
``chroma_radius'`
``chroma_power'`
``alpha_radius'`
``alpha_power'`

The chroma and alpha parameters are optional. If not specified, they default to the corresponding values set for luma_radius and luma_power.

luma_radius, chroma_radius, and alpha_radius represent the radius in pixels of the box used for blurring the corresponding input plane. They are expressions, and can contain the following constants:

``w, h'`

  The input width and height in pixels.

``cw, ch'`

  The input chroma image width and height in pixels.

``hsub, vsub'`

  The horizontal and vertical chroma subsample values. For example, for the pixel format "yuv422p", hsub is 2 and vsub is 1.

The radius must be a non-negative number, and must not be greater than the value of the expression `min(w,h)/2` for the luma and alpha planes, and of `min(cw,ch)/2` for the chroma planes.

luma_power, chroma_power, and alpha_power represent how many times the boxblur filter is applied to the corresponding plane.

Some examples:

## 8.3 copy

Copy the input source unchanged to the output. This is mainly useful for testing purposes.

## 8.4 crop

Crop the input video to given dimensions.

It accepts the following parameters:

``out_w'`

  The width of the output video.

``out_h'`

  The height of the output video.

``x'`

  The horizontal position, in the input video, of the left edge of the output video.

``y'`

  The vertical position, in the input video, of the top edge of the output video.

The parameters are expressions containing the following constants:

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``x, y'`

  The computed values for x and y. They are evaluated for each new frame.

``in_w, in_h'`

  The input width and height.

``iw, ih'`

  These are the same as in_w and in_h.

``out_w, out_h'`

  The output (cropped) width and height.

``ow, oh'`

  These are the same as out_w and out_h.

``n'`

  The number of the input frame, starting from 0.

``t'`

  The timestamp expressed in seconds. It's NAN if the input timestamp is unknown.

The out_w and out_h parameters specify the expressions for the width and height of the output (cropped) video. They are only evaluated during the configuration of the filter.

The default value of out_w is "in_w", and the default value of out_h is "in_h".

The expression for out_w may depend on the value of out_h, and the expression for out_h may depend on out_w, but they cannot depend on x and y, as x and y are evaluated after out_w and out_h.

The x and y parameters specify the expressions for the position of the top-left corner of the output (non-cropped) area. They are evaluated for each frame. If the evaluated value is not valid, it is approximated to the nearest valid value.

The default value of x is "(in_w-out_w)/2", and the default value for y is "(in_h-out_h)/2", which set the cropped area at the center of the input image.

The expression for x may depend on y, and the expression for y may depend on x.

Some examples:

    # Crop the central input area with size 100x100
    crop=out_w=100:out_h=100

    # Crop the central input area with size 2/3 of the input video
    "crop=out_w=2/3*in_w:out_h=2/3*in_h"

    # Crop the input video central square
    crop=out_w=in_h

    # Delimit the rectangle with the top-left corner placed at position
    # 100:100 and the right-bottom corner corresponding to the right-bottom
    # corner of the input image
    crop=out_w=in_w-100:out_h=in_h-100:x=100:y=100

    # Crop 10 pixels from the left and right borders, and 20 pixels from
    # the top and bottom borders
    "crop=out_w=in_w-2*10:out_h=in_h-2*20"

    # Keep only the bottom right quarter of the input image
    "crop=out_w=in_w/2:out_h=in_h/2:x=in_w/2:y=in_h/2"

    # Crop height for getting Greek harmony
    "crop=out_w=in_w:out_h=1/PHI*in_w"

    # Trembling effect
    "crop=in_w/2:in_h/2:(in_w-out_w)/2+((in_w-out_w)/2)*sin(n/10):(in_h-out_h)/2 +((in_h-out_h)/2)*sin(n/7)"

    # Erratic camera effect depending on timestamp
    "crop=out_w=in_w/2:out_h=in_h/2:x=(in_w-out_w)/2+((in_w-out_w)/2)*sin(t*10):y=(in_h-out_h)/2 +((in_h-out_h)/2)*sin(t*13)"

    # Set x depending on the value of y
    "crop=in_w/2:in_h/2:y:10+10*sin(n/10)"

## 8.5 cropdetect

Auto-detect the crop size.

It calculates the necessary cropping parameters and prints the recommended parameters via the logging system. The detected dimensions correspond to the non-black area of the input video.

It accepts the following parameters:

``limit'`

  The threshold, an optional parameter between nothing (0) and everything (255). It defaults to 24.

``round'`

  The value which the width/height should be divisible by. It defaults to 16. The offset is automatically adjusted to center the video. Use 2 to get only even dimensions (needed for 4:2:2 video). 16 is best when encoding to most video codecs.

``reset'`

  A counter that determines how many frames cropdetect will reset the previously detected largest video area after. It will then start over and detect the current optimal crop area. It defaults to 0.

  This can be useful when channel logos distort the video area. 0 indicates 'never reset', and returns the largest area encountered during playback.

## 8.6 delogo

Suppress a TV station logo by a simple interpolation of the surrounding pixels. Just set a rectangle covering the logo and watch it disappear (and sometimes something even uglier appear - your mileage may vary).

It accepts the following parameters:

``x, y'`

  Specify the top left corner coordinates of the logo. They must be specified.

``w, h'`

  Specify the width and height of the logo to clear. They must be specified.

``band, t'`

  Specify the thickness of the fuzzy edge of the rectangle (added to w and h). The default value is 4.

``show'`

  When set to 1, a green rectangle is drawn on the screen to simplify finding the right x, y, w, h parameters, and band is set to 4. The default value is 0.

An example:

## 8.7 drawbox

Draw a colored box on the input image.

It accepts the following parameters:

``x, y'`

  Specify the top left corner coordinates of the box. It defaults to 0.

``width, height'`

  Specify the width and height of the box; if 0 they are interpreted as the input width and height. It defaults to 0.

``color'`

  Specify the color of the box to write. It can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence.

Some examples:

    # Draw a black box around the edge of the input image
    drawbox

    # Draw a box with color red and an opacity of 50%
    drawbox=x=10:y=20:width=200:height=60:color=red@0.5"

## 8.8 drawtext

Draw a text string or text from a specified file on top of a video, using the libfreetype library.

To enable compilation of this filter, you need to configure Libav with `--enable-libfreetype`. To enable default font fallback and the font option you need to configure Libav with `--enable-libfontconfig`.

The filter also recognizes strftime() sequences in the provided text and expands them accordingly. Check the documentation of strftime().

It accepts the following parameters:

``font'`

  The font family to be used for drawing text. By default Sans.

``fontfile'`

  The font file to be used for drawing text. The path must be included. This parameter is mandatory if the fontconfig support is disabled.

``text'`

  The text string to be drawn. The text must be a sequence of UTF-8 encoded characters. This parameter is mandatory if no file is specified with the parameter textfile.

``textfile'`

  A text file containing text to be drawn. The text must be a sequence of UTF-8 encoded characters.

  This parameter is mandatory if no text string is specified with the parameter text.

  If both text and textfile are specified, an error is thrown.

``x, y'`

  The offsets where text will be drawn within the video frame. It is relative to the top/left border of the output image. They accept expressions similar to the overlay filter:

  ``x, y'`

    The computed values for x and y. They are evaluated for each new frame.

  ``main_w, main_h'`

    The main input width and height.

  ``W, H'`

    These are the same as main_w and main_h.

  ``text_w, text_h'`

    The rendered text's width and height.

  ``w, h'`

    These are the same as text_w and text_h.

  ``n'`

    The number of frames processed, starting from 0.

  ``t'`

    The timestamp, expressed in seconds. It's NAN if the input timestamp is unknown.

  The default value of x and y is 0.

``fontsize'`

  The font size to be used for drawing text. The default value of fontsize is 16.

``fontcolor'`

  The color to be used for drawing fonts. It is either a string (e.g. "red"), or in 0xRRGGBB[AA] format (e.g. "0xff000033"), possibly followed by an alpha specifier. The default value of fontcolor is "black".

``boxcolor'`

  The color to be used for drawing box around text. It is either a string (e.g. "yellow") or in 0xRRGGBB[AA] format (e.g. "0xff00ff"), possibly followed by an alpha specifier. The default value of boxcolor is "white".

``box'`

  Used to draw a box around text using the background color. The value must be either 1 (enable) or 0 (disable). The default value of box is 0.

``shadowx, shadowy'`

  The x and y offsets for the text shadow position with respect to the position of the text. They can be either positive or negative values. The default value for both is "0".

``shadowcolor'`

  The color to be used for drawing a shadow behind the drawn text. It can be a color name (e.g. "yellow") or a string in the 0xRRGGBB[AA] form (e.g. "0xff00ff"), possibly followed by an alpha specifier. The default value of shadowcolor is "black".

``ft_load_flags'`

  The flags to be used for loading the fonts.

  The flags map the corresponding flags supported by libfreetype, and are a combination of the following values:

  default
  no_scale
  no_hinting
  render
  no_bitmap
  vertical_layout
  force_autohint
  crop_bitmap
  pedantic
  ignore_global_advance_width
  no_recurse
  ignore_transform
  monochrome
  linear_design
  no_autohint
  end table

  Default value is "render".

  For more information consult the documentation for the FT_LOAD_* libfreetype flags.

``tabsize'`

  The size in number of spaces to use for rendering the tab. Default value is 4.

``fix_bounds'`

  If true, check and fix text coords to avoid clipping.

For example the command:

    drawtext="fontfile=/usr/share/fonts/truetype/freefont/FreeSerif.ttf: text='Test Text'"

will draw "Test Text" with font FreeSerif, using the default values for the optional parameters.

The command:

    drawtext="fontfile=/usr/share/fonts/truetype/freefont/FreeSerif.ttf: text='Test Text':\
              x=100: y=50: fontsize=24: fontcolor=yellow@0.2: box=1: boxcolor=red@0.2"

will draw 'Test Text' with font FreeSerif of size 24 at position x=100 and y=50 (counting from the top-left corner of the screen), text is yellow with a red box around it. Both the text and the box have an opacity of 20%.

Note that the double quotes are not necessary if spaces are not used within the parameter list.

For more information about libfreetype, check: http://www.freetype.org/.

## 8.9 fade

Apply a fade-in/out effect to the input video.

It accepts the following parameters:

``type'`

  The effect type can be either "in" for a fade-in, or "out" for a fade-out effect.

``start_frame'`

  The number of the frame to start applying the fade effect at.

``nb_frames'`

  The number of frames that the fade effect lasts. At the end of the fade-in effect, the output video will have the same intensity as the input video. At the end of the fade-out transition, the output video will be completely black.

Some examples:

    # Fade in the first 30 frames of video
    fade=type=in:nb_frames=30

    # Fade out the last 45 frames of a 200-frame video
    fade=type=out:start_frame=155:nb_frames=45

    # Fade in the first 25 frames and fade out the last 25 frames of a 1000-frame video
    fade=type=in:start_frame=0:nb_frames=25, fade=type=out:start_frame=975:nb_frames=25

    # Make the first 5 frames black, then fade in from frame 5-24
    fade=type=in:start_frame=5:nb_frames=20

## 8.10 fieldorder

Transform the field order of the input video.

It accepts the following parameters:

``order'`

  The output field order. Valid values are tff for top field first or bff for bottom field first.

The default value is "tff".

The transformation is done by shifting the picture content up or down by one line, and filling the remaining line with appropriate picture content. This method is consistent with most broadcast field order converters.

If the input video is not flagged as being interlaced, or it is already flagged as being of the required output field order, then this filter does not alter the incoming video.

It is very useful when converting to or from PAL DV material, which is bottom field first.

For example:

    ./avconv -i in.vob -vf "fieldorder=order=bff" out.dv

## 8.11 fifo

Buffer input images and send them when they are requested.

It is mainly useful when auto-inserted by the libavfilter framework.

It does not take parameters.

## 8.12 format

Convert the input video to one of the specified pixel formats. Libavfilter will try to pick one that is suitable as input to the next filter.

It accepts the following parameters:

``pix_fmts'`

  A '|'-separated list of pixel format names, such as "pix_fmts=yuv420p|monow|rgb24".

Some examples:

    # Convert the input video to the "yuv420p" format
    format=pix_fmts=yuv420p

    # Convert the input video to any of the formats in the list
    format=pix_fmts=yuv420p|yuv444p|yuv410p

## 8.13 fps

Convert the video to specified constant framerate by duplicating or dropping frames as necessary.

It accepts the following parameters:

``fps'`

  The desired output framerate.

``start_time'`

  Assume the first PTS should be the given value, in seconds. This allows for padding/trimming at the start of stream. By default, no assumption is made about the first frame's expected PTS, so no padding or trimming is done. For example, this could be set to 0 to pad the beginning with duplicates of the first frame if a video stream starts after the audio stream or to trim any frames with a negative PTS.

## 8.14 framepack

Pack two different video streams into a stereoscopic video, setting proper metadata on supported codecs. The two views should have the same size and framerate and processing will stop when the shorter video ends. Please note that you may conveniently adjust view properties with the scale and fps filters.

It accepts the following parameters:

``format'`

  The desired packing format. Supported values are:

  ``sbs'`

    The views are next to each other (default).

  ``tab'`

    The views are on top of each other.

  ``lines'`

    The views are packed by line.

  ``columns'`

    The views are packed by column.

  ``frameseq'`

    The views are temporally interleaved.

Some examples:

    # Convert left and right views into a frame-sequential video
    avconv -i LEFT -i RIGHT -filter_complex framepack=frameseq OUTPUT

    # Convert views into a side-by-side video with the same output resolution as the input
    avconv -i LEFT -i RIGHT -filter_complex [0:v]scale=w=iw/2[left],[1:v]scale=w=iw/2[right],[left][right]framepack=sbs OUTPUT

## 8.15 frei0r

Apply a frei0r effect to the input video.

To enable the compilation of this filter, you need to install the frei0r header and configure Libav with -enable-frei0r.

It accepts the following parameters:

``filter_name'`

  The name of the frei0r effect to load. If the environment variable `FREI0R_PATH` is defined, the frei0r effect is searched for in each of the directories specified by the colon-separated list in `FREIOR_PATH`. Otherwise, the standard frei0r paths are searched, in this order: ``HOME/.frei0r-1/lib/'`, ``/usr/local/lib/frei0r-1/'`, ``/usr/lib/frei0r-1/'`.

``filter_params'`

  A '|'-separated list of parameters to pass to the frei0r effect.

A frei0r effect parameter can be a boolean (its value is either "y" or "n"), a double, a color (specified as R/G/B, where R, G, and B are floating point numbers between 0.0 and 1.0, inclusive) or by an `av_parse_color()` color description), a position (specified as X/Y, where X and Y are floating point numbers) and/or a string.

The number and types of parameters depend on the loaded effect. If an effect parameter is not specified, the default value is set.

Some examples:

    # Apply the distort0r effect, setting the first two double parameters
    frei0r=filter_name=distort0r:filter_params=0.5|0.01

    # Apply the colordistance effect, taking a color as the first parameter
    frei0r=colordistance:0.2/0.3/0.4
    frei0r=colordistance:violet
    frei0r=colordistance:0x112233

    # Apply the perspective effect, specifying the top left and top right
    # image positions
    frei0r=perspective:0.2/0.2|0.8/0.2

For more information, see http://piksel.org/frei0r

## 8.16 gradfun

Fix the banding artifacts that are sometimes introduced into nearly flat regions by truncation to 8bit colordepth. Interpolate the gradients that should go where the bands are, and dither them.

It is designed for playback only. Do not use it prior to lossy compression, because compression tends to lose the dither and bring back the bands.

It accepts the following parameters:

``strength'`

  The maximum amount by which the filter will change any one pixel. This is also the threshold for detecting nearly flat regions. Acceptable values range from .51 to 64; the default value is 1.2. Out-of-range values will be clipped to the valid range.

``radius'`

  The neighborhood to fit the gradient to. A larger radius makes for smoother gradients, but also prevents the filter from modifying the pixels near detailed regions. Acceptable values are 8-32; the default value is 16. Out-of-range values will be clipped to the valid range.

    # Default parameters
    gradfun=strength=1.2:radius=16

    # Omitting the radius
    gradfun=1.2

## 8.17 hflip

Flip the input video horizontally.

For example, to horizontally flip the input video with `avconv`:

    avconv -i in.avi -vf "hflip" out.avi

## 8.18 hqdn3d

This is a high precision/quality 3d denoise filter. It aims to reduce image noise, producing smooth images and making still images really still. It should enhance compressibility.

It accepts the following optional parameters:

``luma_spatial'`

  A non-negative floating point number which specifies spatial luma strength. It defaults to 4.0.

``chroma_spatial'`

  A non-negative floating point number which specifies spatial chroma strength. It defaults to 3.0*luma_spatial/4.0.

``luma_tmp'`

  A floating point number which specifies luma temporal strength. It defaults to 6.0*luma_spatial/4.0.

``chroma_tmp'`

  A floating point number which specifies chroma temporal strength. It defaults to luma_tmp*chroma_spatial/luma_spatial.

## 8.19 interlace

Simple interlacing filter from progressive contents. This interleaves upper (or lower) lines from odd frames with lower (or upper) lines from even frames, halving the frame rate and preserving image height.

       Original        Original             New Frame
       Frame 'j'      Frame 'j+1'             (tff)
      ==========      ===========       ==================
        Line 0  -------------------->    Frame 'j' Line 0
        Line 1          Line 1  ---->   Frame 'j+1' Line 1
        Line 2 --------------------->    Frame 'j' Line 2
        Line 3          Line 3  ---->   Frame 'j+1' Line 3
         ...             ...                   ...
    New Frame + 1 will be generated by Frame 'j+2' and Frame 'j+3' and so on

It accepts the following optional parameters:

``scan'`

  This determines whether the interlaced frame is taken from the even (tff - default) or odd (bff) lines of the progressive frame.

``lowpass'`

  Enable (default) or disable the vertical lowpass filter to avoid twitter interlacing and reduce moire patterns.

## 8.20 lut, lutrgb, lutyuv

Compute a look-up table for binding each pixel component input value to an output value, and apply it to the input video.

lutyuv applies a lookup table to a YUV input video, lutrgb to an RGB input video.

These filters accept the following parameters:

``c0 (first pixel component)'`
``c1 (second pixel component)'`
``c2 (third pixel component)'`
``c3 (fourth pixel component, corresponds to the alpha component)'`
``r (red component)'`
``g (green component)'`
``b (blue component)'`
``a (alpha component)'`
``y (Y/luminance component)'`
``u (U/Cb component)'`
``v (V/Cr component)'`

Each of them specifies the expression to use for computing the lookup table for the corresponding pixel component values.

The exact component associated to each of the c* options depends on the format in input.

The lut filter requires either YUV or RGB pixel formats in input, lutrgb requires RGB pixel formats in input, and lutyuv requires YUV.

The expressions can contain the following constants and functions:

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``w, h'`

  The input width and height.

``val'`

  The input value for the pixel component.

``clipval'`

  The input value, clipped to the minval-maxval range.

``maxval'`

  The maximum value for the pixel component.

``minval'`

  The minimum value for the pixel component.

``negval'`

  The negated value for the pixel component value, clipped to the minval-maxval range; it corresponds to the expression "maxval-clipval+minval".

``clip(val)'`

  The computed value in val, clipped to the minval-maxval range.

``gammaval(gamma)'`

  The computed gamma correction value of the pixel component value, clipped to the minval-maxval range. It corresponds to the expression "pow((clipval-minval)/(maxval-minval)\,gamma)*(maxval-minval)+minval"

All expressions default to "val".

Some examples:

    # Negate input video
    lutrgb="r=maxval+minval-val:g=maxval+minval-val:b=maxval+minval-val"
    lutyuv="y=maxval+minval-val:u=maxval+minval-val:v=maxval+minval-val"

    # The above is the same as
    lutrgb="r=negval:g=negval:b=negval"
    lutyuv="y=negval:u=negval:v=negval"

    # Negate luminance
    lutyuv=negval

    # Remove chroma components, turning the video into a graytone image
    lutyuv="u=128:v=128"

    # Apply a luma burning effect
    lutyuv="y=2*val"

    # Remove green and blue components
    lutrgb="g=0:b=0"

    # Set a constant alpha channel value on input
    format=rgba,lutrgb=a="maxval-minval/2"

    # Correct luminance gamma by a factor of 0.5
    lutyuv=y=gammaval(0.5)

## 8.21 negate

Negate input video.

It accepts an integer in input; if non-zero it negates the alpha component (if available). The default value in input is 0.

## 8.22 noformat

Force libavfilter not to use any of the specified pixel formats for the input to the next filter.

It accepts the following parameters:

``pix_fmts'`

  A '|'-separated list of pixel format names, such as apix_fmts=yuv420p|monow|rgb24".

Some examples:

    # Force libavfilter to use a format different from "yuv420p" for the
    # input to the vflip filter
    noformat=pix_fmts=yuv420p,vflip

    # Convert the input video to any of the formats not contained in the list
    noformat=yuv420p|yuv444p|yuv410p

## 8.23 null

Pass the video source unchanged to the output.

## 8.24 ocv

Apply a video transform using libopencv.

To enable this filter, install the libopencv library and headers and configure Libav with -enable-libopencv.

It accepts the following parameters:

``filter_name'`

  The name of the libopencv filter to apply.

``filter_params'`

  The parameters to pass to the libopencv filter. If not specified, the default values are assumed.

Refer to the official libopencv documentation for more precise information: http://opencv.willowgarage.com/documentation/c/image_filtering.html

Several libopencv filters are supported; see the following subsections.

### 8.24.1 dilate

Dilate an image by using a specific structuring element. It corresponds to the libopencv function `cvDilate`.

It accepts the parameters: struct_el|nb_iterations.

struct_el represents a structuring element, and has the syntax: colsxrows+anchor_xxanchor_y/shape

cols and rows represent the number of columns and rows of the structuring element, anchor_x and anchor_y the anchor point, and shape the shape for the structuring element. shape must be "rect", "cross", "ellipse", or "custom".

If the value for shape is "custom", it must be followed by a string of the form "=filename". The file with name filename is assumed to represent a binary image, with each printable character corresponding to a bright pixel. When a custom shape is used, cols and rows are ignored, the number or columns and rows of the read file are assumed instead.

The default value for struct_el is "3x3+0x0/rect".

nb_iterations specifies the number of times the transform is applied to the image, and defaults to 1.

Some examples:

    # Use the default values
    ocv=dilate

    # Dilate using a structuring element with a 5x5 cross, iterating two times
    ocv=filter_name=dilate:filter_params=5x5+2x2/cross|2

    # Read the shape from the file diamond.shape, iterating two times.
    # The file diamond.shape may contain a pattern of characters like this
    #   *
    #  ***
    # *****
    #  ***
    #   *
    # The specified columns and rows are ignored
    # but the anchor point coordinates are not
    ocv=dilate:0x0+2x2/custom=diamond.shape|2

### 8.24.2 erode

Erode an image by using a specific structuring element. It corresponds to the libopencv function `cvErode`.

It accepts the parameters: struct_el:nb_iterations, with the same syntax and semantics as the dilate filter.

### 8.24.3 smooth

Smooth the input video.

The filter takes the following parameters: type|param1|param2|param3|param4.

type is the type of smooth filter to apply, and must be one of the following values: "blur", "blur_no_scale", "median", "gaussian", or "bilateral". The default value is "gaussian".

The meaning of param1, param2, param3, and param4 depend on the smooth type. param1 and param2 accept integer positive values or 0. param3 and param4 accept floating point values.

The default value for param1 is 3. The default value for the other parameters is 0.

These parameters correspond to the parameters assigned to the libopencv function `cvSmooth`.

## 8.25 overlay

Overlay one video on top of another.

It takes two inputs and has one output. The first input is the "main" video on which the second input is overlayed.

It accepts the following parameters:

``x'`

  The horizontal position of the left edge of the overlaid video on the main video.

``y'`

  The vertical position of the top edge of the overlaid video on the main video.

The parameters are expressions containing the following parameters:

``main_w, main_h'`

  The main input width and height.

``W, H'`

  These are the same as main_w and main_h.

``overlay_w, overlay_h'`

  The overlay input width and height.

``w, h'`

  These are the same as overlay_w and overlay_h.

``eof_action'`

  The action to take when EOF is encountered on the secondary input; it accepts one of the following values:

  ``repeat'`

    Repeat the last frame (the default).

  ``endall'`

    End both streams.

  ``pass'`

    Pass the main input through.

Be aware that frames are taken from each input video in timestamp order, hence, if their initial timestamps differ, it is a a good idea to pass the two inputs through a setpts=PTS-STARTPTS filter to have them begin in the same zero timestamp, as the example for the movie filter does.

Some examples:

    # Draw the overlay at 10 pixels from the bottom right
    # corner of the main video
    overlay=x=main_w-overlay_w-10:y=main_h-overlay_h-10

    # Insert a transparent PNG logo in the bottom left corner of the input
    avconv -i input -i logo -filter_complex 'overlay=x=10:y=main_h-overlay_h-10' output

    # Insert 2 different transparent PNG logos (second logo on bottom
    # right corner)
    avconv -i input -i logo1 -i logo2 -filter_complex
    'overlay=x=10:y=H-h-10,overlay=x=W-w-10:y=H-h-10' output

    # Add a transparent color layer on top of the main video;
    # WxH specifies the size of the main input to the overlay filter
    color=red.3:WxH [over]; [in][over] overlay [out]

    # Mask 10-20 seconds of a video by applying the delogo filter to a section
    avconv -i test.avi -codec:v:0 wmv2 -ar 11025 -b:v 9000k
    -vf '[in]split[split_main][split_delogo];[split_delogo]trim=start=360:end=371,delogo=0:0:640:480[delogoed];[split_main][delogoed]overlay=eof_action=pass[out]'
    masked.avi

You can chain together more overlays but the efficiency of such approach is yet to be tested.

## 8.26 pad

Add paddings to the input image, and place the original input at the provided x, y coordinates.

It accepts the following parameters:

``width, height'`

  Specify the size of the output image with the paddings added. If the value for width or height is 0, the corresponding input size is used for the output.

  The width expression can reference the value set by the height expression, and vice versa.

  The default value of width and height is 0.

``x, y'`

  Specify the offsets to place the input image at within the padded area, with respect to the top/left border of the output image.

  The x expression can reference the value set by the y expression, and vice versa.

  The default value of x and y is 0.

``color'`

  Specify the color of the padded area. It can be the name of a color (case insensitive match) or an 0xRRGGBB[AA] sequence.

  The default value of color is "black".

The parameters width, height, x, and y are expressions containing the following constants:

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``in_w, in_h'`

  The input video width and height.

``iw, ih'`

  These are the same as in_w and in_h.

``out_w, out_h'`

  The output width and height (the size of the padded area), as specified by the width and height expressions.

``ow, oh'`

  These are the same as out_w and out_h.

``x, y'`

  The x and y offsets as specified by the x and y expressions, or NAN if not yet specified.

``a'`

  The input display aspect ratio, same as iw / ih.

``hsub, vsub'`

  The horizontal and vertical chroma subsample values. For example for the pixel format "yuv422p" hsub is 2 and vsub is 1.

Some examples:

    # Add paddings with the color "violet" to the input video. The output video
    # size is 640x480, and the top-left corner of the input video is placed at
    # column 0, row 40
    pad=width=640:height=480:x=0:y=40:color=violet

    # Pad the input to get an output with dimensions increased by 3/2,
    # and put the input video at the center of the padded area
    pad="3/2*iw:3/2*ih:(ow-iw)/2:(oh-ih)/2"

    # Pad the input to get a squared output with size equal to the maximum
    # value between the input width and height, and put the input video at
    # the center of the padded area
    pad="max(iw\,ih):ow:(ow-iw)/2:(oh-ih)/2"

    # Pad the input to get a final w/h ratio of 16:9
    pad="ih*16/9:ih:(ow-iw)/2:(oh-ih)/2"

    # Double the output size and put the input video in the bottom-right
    # corner of the output padded area
    pad="2*iw:2*ih:ow-iw:oh-ih"

## 8.27 pixdesctest

Pixel format descriptor test filter, mainly useful for internal testing. The output video should be equal to the input video.

For example:

    format=monow, pixdesctest

can be used to test the monowhite pixel format descriptor definition.

## 8.28 scale

Scale the input video and/or convert the image format.

It accepts the following parameters:

``w'`

  The output video width.

``h'`

  The output video height.

The parameters w and h are expressions containing the following constants:

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``in_w, in_h'`

  The input width and height.

``iw, ih'`

  These are the same as in_w and in_h.

``out_w, out_h'`

  The output (cropped) width and height.

``ow, oh'`

  These are the same as out_w and out_h.

``a'`

  This is the same as iw / ih.

``sar'`

  input sample aspect ratio

``dar'`

  The input display aspect ratio; it is the same as (iw / ih) * sar.

``hsub, vsub'`

  The horizontal and vertical chroma subsample values. For example, for the pixel format "yuv422p" hsub is 2 and vsub is 1.

If the input image format is different from the format requested by the next filter, the scale filter will convert the input to the requested format.

If the value for w or h is 0, the respective input size is used for the output.

If the value for w or h is -1, the scale filter will use, for the respective output size, a value that maintains the aspect ratio of the input image.

The default value of w and h is 0.

Some examples:

    # Scale the input video to a size of 200x100
    scale=w=200:h=100

    # Scale the input to 2x
    scale=w=2*iw:h=2*ih
    # The above is the same as
    scale=2*in_w:2*in_h

    # Scale the input to half the original size
    scale=w=iw/2:h=ih/2

    # Increase the width, and set the height to the same size
    scale=3/2*iw:ow

    # Seek Greek harmony
    scale=iw:1/PHI*iw
    scale=ih*PHI:ih

    # Increase the height, and set the width to 3/2 of the height
    scale=w=3/2*oh:h=3/5*ih

    # Increase the size, making the size a multiple of the chroma
    scale="trunc(3/2*iw/hsub)*hsub:trunc(3/2*ih/vsub)*vsub"

    # Increase the width to a maximum of 500 pixels,
    # keeping the same aspect ratio as the input
    scale=w='min(500\, iw*3/2):h=-1'

## 8.29 select

Select frames to pass in output.

It accepts the following parameters:

``expr'`

  An expression, which is evaluated for each input frame. If the expression is evaluated to a non-zero value, the frame is selected and passed to the output, otherwise it is discarded.

The expression can contain the following constants:

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``n'`

  The (sequential) number of the filtered frame, starting from 0.

``selected_n'`

  The (sequential) number of the selected frame, starting from 0.

``prev_selected_n'`

  The sequential number of the last selected frame. It's NAN if undefined.

``TB'`

  The timebase of the input timestamps.

``pts'`

  The PTS (Presentation TimeStamp) of the filtered video frame, expressed in TB units. It's NAN if undefined.

``t'`

  The PTS of the filtered video frame, expressed in seconds. It's NAN if undefined.

``prev_pts'`

  The PTS of the previously filtered video frame. It's NAN if undefined.

``prev_selected_pts'`

  The PTS of the last previously filtered video frame. It's NAN if undefined.

``prev_selected_t'`

  The PTS of the last previously selected video frame. It's NAN if undefined.

``start_pts'`

  The PTS of the first video frame in the video. It's NAN if undefined.

``start_t'`

  The time of the first video frame in the video. It's NAN if undefined.

``pict_type'`

  The type of the filtered frame. It can assume one of the following values:

  ``I'`
  ``P'`
  ``B'`
  ``S'`
  ``SI'`
  ``SP'`
  ``BI'`
``interlace_type'`

  The frame interlace type. It can assume one of the following values:

  ``PROGRESSIVE'`

    The frame is progressive (not interlaced).

  ``TOPFIRST'`

    The frame is top-field-first.

  ``BOTTOMFIRST'`

    The frame is bottom-field-first.

``key'`

  This is 1 if the filtered frame is a key-frame, 0 otherwise.

The default value of the select expression is "1".

Some examples:

    # Select all the frames in input
    select

    # The above is the same as
    select=expr=1

    # Skip all frames
    select=expr=0

    # Select only I-frames
    select='expr=eq(pict_type\,I)'

    # Select one frame per 100
    select='not(mod(n\,100))'

    # Select only frames contained in the 10-20 time interval
    select='gte(t\,10)*lte(t\,20)'

    # Select only I frames contained in the 10-20 time interval
    select='gte(t\,10)*lte(t\,20)*eq(pict_type\,I)'

    # Select frames with a minimum distance of 10 seconds
    select='isnan(prev_selected_t)+gte(t-prev_selected_t\,10)'

## 8.30 setdar

Set the Display Aspect Ratio for the filter output video.

This is done by changing the specified Sample (aka Pixel) Aspect Ratio, according to the following equation: DAR = HORIZONTAL_RESOLUTION / VERTICAL_RESOLUTION * SAR

Keep in mind that this filter does not modify the pixel dimensions of the video frame. Also, the display aspect ratio set by this filter may be changed by later filters in the filterchain, e.g. in case of scaling or if another "setdar" or a "setsar" filter is applied.

It accepts the following parameters:

``dar'`

  The output display aspect ratio.

The parameter dar is an expression containing the following constants:

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``w, h'`

  The input width and height.

``a'`

  This is the same as w / h.

``sar'`

  The input sample aspect ratio.

``dar'`

  The input display aspect ratio. It is the same as (w / h) * sar.

``hsub, vsub'`

  The horizontal and vertical chroma subsample values. For example, for the pixel format "yuv422p" hsub is 2 and vsub is 1.

To change the display aspect ratio to 16:9, specify:

    setdar=dar=16/9
    # The above is equivalent to
    setdar=dar=1.77777

Also see the the setsar filter documentation.

## 8.31 setpts

Change the PTS (presentation timestamp) of the input video frames.

It accepts the following parameters:

``expr'`

  The expression which is evaluated for each frame to construct its timestamp.

The expression is evaluated through the eval API and can contain the following constants:

``PTS'`

  The presentation timestamp in input.

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``N'`

  The count of the input frame, starting from 0.

``STARTPTS'`

  The PTS of the first video frame.

``INTERLACED'`

  State whether the current frame is interlaced.

``PREV_INPTS'`

  The previous input PTS.

``PREV_OUTPTS'`

  The previous output PTS.

``RTCTIME'`

  The wallclock (RTC) time in microseconds.

``RTCSTART'`

  The wallclock (RTC) time at the start of the movie in microseconds.

``TB'`

  The timebase of the input timestamps.

Some examples:

    # Start counting the PTS from zero
    setpts=expr=PTS-STARTPTS

    # Fast motion
    setpts=expr=0.5*PTS

    # Slow motion
    setpts=2.0*PTS

    # Fixed rate 25 fps
    setpts=N/(25*TB)

    # Fixed rate 25 fps with some jitter
    setpts='1/(25*TB) * (N + 0.05 * sin(N*2*PI/25))'

    # Generate timestamps from a "live source" and rebase onto the current timebase
    setpts='(RTCTIME - RTCSTART) / (TB * 1000000)"

## 8.32 setsar

Set the Sample (aka Pixel) Aspect Ratio for the filter output video.

Note that as a consequence of the application of this filter, the output display aspect ratio will change according to the following equation: DAR = HORIZONTAL_RESOLUTION / VERTICAL_RESOLUTION * SAR

Keep in mind that the sample aspect ratio set by this filter may be changed by later filters in the filterchain, e.g. if another "setsar" or a "setdar" filter is applied.

It accepts the following parameters:

``sar'`

  The output sample aspect ratio.

The parameter sar is an expression containing the following constants:

``E, PI, PHI'`

  These are approximated values for the mathematical constants e (Euler's number), pi (Greek pi), and phi (the golden ratio).

``w, h'`

  The input width and height.

``a'`

  These are the same as w / h.

``sar'`

  The input sample aspect ratio.

``dar'`

  The input display aspect ratio. It is the same as (w / h) * sar.

``hsub, vsub'`

  Horizontal and vertical chroma subsample values. For example, for the pixel format "yuv422p" hsub is 2 and vsub is 1.

To change the sample aspect ratio to 10:11, specify:

    setsar=sar=10/11

## 8.33 settb

Set the timebase to use for the output frames timestamps. It is mainly useful for testing timebase configuration.

It accepts the following parameters:

``expr'`

  The expression which is evaluated into the output timebase.

The expression can contain the constants "PI", "E", "PHI", "AVTB" (the default timebase), and "intb" (the input timebase).

The default value for the input is "intb".

Some examples:

    # Set the timebase to 1/25
    settb=expr=1/25

    # Set the timebase to 1/10
    settb=expr=0.1

    # Set the timebase to 1001/1000
    settb=1+0.001

    #Set the timebase to 2*intb
    settb=2*intb

    #Set the default timebase value
    settb=AVTB

## 8.34 showinfo

Show a line containing various information for each input video frame. The input video is not modified.

The shown line contains a sequence of key/value pairs of the form key:value.

It accepts the following parameters:

``n'`

  The (sequential) number of the input frame, starting from 0.

``pts'`

  The Presentation TimeStamp of the input frame, expressed as a number of time base units. The time base unit depends on the filter input pad.

``pts_time'`

  The Presentation TimeStamp of the input frame, expressed as a number of seconds.

``pos'`

  The position of the frame in the input stream, or -1 if this information is unavailable and/or meaningless (for example in case of synthetic video).

``fmt'`

  The pixel format name.

``sar'`

  The sample aspect ratio of the input frame, expressed in the form num/den.

``s'`

  The size of the input frame, expressed in the form widthxheight.

``i'`

  The type of interlaced mode ("P" for "progressive", "T" for top field first, "B" for bottom field first).

``iskey'`

  This is 1 if the frame is a key frame, 0 otherwise.

``type'`

  The picture type of the input frame ("I" for an I-frame, "P" for a P-frame, "B" for a B-frame, or "?" for an unknown type). Also refer to the documentation of the `AVPictureType` enum and of the `av_get_picture_type_char` function defined in ``libavutil/avutil.h'`.

``checksum'`

  The Adler-32 checksum of all the planes of the input frame.

``plane_checksum'`

  The Adler-32 checksum of each plane of the input frame, expressed in the form "[c0 c1 c2 c3]".

## 8.35 shuffleplanes

Reorder and/or duplicate video planes.

It accepts the following parameters:

``map0'`

  The index of the input plane to be used as the first output plane.

``map1'`

  The index of the input plane to be used as the second output plane.

``map2'`

  The index of the input plane to be used as the third output plane.

``map3'`

  The index of the input plane to be used as the fourth output plane.

The first plane has the index 0. The default is to keep the input unchanged.

Swap the second and third planes of the input:

    avconv -i INPUT -vf shuffleplanes=0:2:1:3 OUTPUT

## 8.36 split

Split input video into several identical outputs.

It accepts a single parameter, which specifies the number of outputs. If unspecified, it defaults to 2.

Create 5 copies of the input video:

    avconv -i INPUT -filter_complex split=5 OUTPUT

## 8.37 transpose

Transpose rows with columns in the input video and optionally flip it.

It accepts the following parameters:

``dir'`

  The direction of the transpose.

The direction can assume the following values:

``cclock_flip'`

  Rotate by 90 degrees counterclockwise and vertically flip (default), that is:

      L.R     L.l
      . . ->  . .
      l.r     R.r

``clock'`

  Rotate by 90 degrees clockwise, that is:

      L.R     l.L
      . . ->  . .
      l.r     r.R

``cclock'`

  Rotate by 90 degrees counterclockwise, that is:

      L.R     R.r
      . . ->  . .
      l.r     L.l

``clock_flip'`

  Rotate by 90 degrees clockwise and vertically flip, that is:

      L.R     r.R
      . . ->  . .
      l.r     l.L

## 8.38 trim

Trim the input so that the output contains one continuous subpart of the input.

It accepts the following parameters:

``start'`

  The timestamp (in seconds) of the start of the kept section. The frame with the timestamp start will be the first frame in the output.

``end'`

  The timestamp (in seconds) of the first frame that will be dropped. The frame immediately preceding the one with the timestamp end will be the last frame in the output.

``start_pts'`

  This is the same as start, except this option sets the start timestamp in timebase units instead of seconds.

``end_pts'`

  This is the same as end, except this option sets the end timestamp in timebase units instead of seconds.

``duration'`

  The maximum duration of the output in seconds.

``start_frame'`

  The number of the first frame that should be passed to the output.

``end_frame'`

  The number of the first frame that should be dropped.

Note that the first two sets of the start/end options and the ``duration'` option look at the frame timestamp, while the _frame variants simply count the frames that pass through the filter. Also note that this filter does not modify the timestamps. If you wish for the output timestamps to start at zero, insert a setpts filter after the trim filter.

If multiple start or end options are set, this filter tries to be greedy and keep all the frames that match at least one of the specified constraints. To keep only the part that matches all the constraints at once, chain multiple trim filters.

The defaults are such that all the input is kept. So it is possible to set e.g. just the end values to keep everything before the specified time.

Examples:

## 8.39 unsharp

Sharpen or blur the input video.

It accepts the following parameters:

``luma_msize_x'`

  Set the luma matrix horizontal size. It must be an integer between 3 and 13. The default value is 5.

``luma_msize_y'`

  Set the luma matrix vertical size. It must be an integer between 3 and 13. The default value is 5.

``luma_amount'`

  Set the luma effect strength. It must be a floating point number between -2.0 and 5.0. The default value is 1.0.

``chroma_msize_x'`

  Set the chroma matrix horizontal size. It must be an integer between 3 and 13. The default value is 5.

``chroma_msize_y'`

  Set the chroma matrix vertical size. It must be an integer between 3 and 13. The default value is 5.

``chroma_amount'`

  Set the chroma effect strength. It must be a floating point number between -2.0 and 5.0. The default value is 0.0.

Negative values for the amount will blur the input video, while positive values will sharpen. All parameters are optional and default to the equivalent of the string '5:5:1.0:5:5:0.0'.

    # Strong luma sharpen effect parameters
    unsharp=luma_msize_x=7:luma_msize_y=7:luma_amount=2.5

    # A strong blur of both luma and chroma parameters
    unsharp=7:7:-2:7:7:-2

    # Use the default values with avconv
    ./avconv -i in.avi -vf "unsharp" out.mp4

## 8.40 vflip

Flip the input video vertically.

    ./avconv -i in.avi -vf "vflip" out.avi

## 8.41 yadif

Deinterlace the input video ("yadif" means "yet another deinterlacing filter").

It accepts the following parameters:

``mode'`

  The interlacing mode to adopt. It accepts one of the following values:

  ``0'`

    Output one frame for each frame.

  ``1'`

    Output one frame for each field.

  ``2'`

    Like 0, but it skips the spatial interlacing check.

  ``3'`

    Like 1, but it skips the spatial interlacing check.

  The default value is 0.

``parity'`

  The picture field parity assumed for the input interlaced video. It accepts one of the following values:

  ``0'`

    Assume the top field is first.

  ``1'`

    Assume the bottom field is first.

  ``-1'`

    Enable automatic detection of field parity.

  The default value is -1. If the interlacing is unknown or the decoder does not export this information, top field first will be assumed.

``auto'`

  Whether the deinterlacer should trust the interlaced flag and only deinterlace frames marked as interlaced.

  ``0'`

    Deinterlace all frames.

  ``1'`

    Only deinterlace frames marked as interlaced.

  The default value is 0.

# 9. Video Sources

Below is a description of the currently available video sources.

## 9.1 buffer

Buffer video frames, and make them available to the filter chain.

This source is mainly intended for a programmatic use, in particular through the interface defined in ``libavfilter/vsrc_buffer.h'`.

It accepts the following parameters:

``width'`

  The input video width.

``height'`

  The input video height.

``pix_fmt'`

  The name of the input video pixel format.

``time_base'`

  The time base used for input timestamps.

``sar'`

  The sample (pixel) aspect ratio of the input video.

For example:

    buffer=width=320:height=240:pix_fmt=yuv410p:time_base=1/24:sar=1

will instruct the source to accept video frames with size 320x240 and with format "yuv410p", assuming 1/24 as the timestamps timebase and square pixels (1:1 sample aspect ratio).

## 9.2 color

Provide an uniformly colored input.

It accepts the following parameters:

``color'`

  Specify the color of the source. It can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence, possibly followed by an alpha specifier. The default value is "black".

``size'`

  Specify the size of the sourced video, it may be a string of the form widthxheight, or the name of a size abbreviation. The default value is "320x240".

``framerate'`

  Specify the frame rate of the sourced video, as the number of frames generated per second. It has to be a string in the format frame_rate_num/frame_rate_den, an integer number, a floating point number or a valid video frame rate abbreviation. The default value is "25".

The following graph description will generate a red source with an opacity of 0.2, with size "qcif" and a frame rate of 10 frames per second, which will be overlayed over the source connected to the pad with identifier "in":

    "color=red@0.2:qcif:10 [color]; [in][color] overlay [out]"

## 9.3 movie

Read a video stream from a movie container.

Note that this source is a hack that bypasses the standard input path. It can be useful in applications that do not support arbitrary filter graphs, but its use is discouraged in those that do. It should never be used with `avconv`; the ``-filter_complex'` option fully replaces it.

It accepts the following parameters:

``filename'`

  The name of the resource to read (not necessarily a file; it can also be a device or a stream accessed through some protocol).

``format_name, f'`

  Specifies the format assumed for the movie to read, and can be either the name of a container or an input device. If not specified, the format is guessed from movie_name or by probing.

``seek_point, sp'`

  Specifies the seek point in seconds. The frames will be output starting from this seek point. The parameter is evaluated with `av_strtod`, so the numerical value may be suffixed by an IS postfix. The default value is "0".

``stream_index, si'`

  Specifies the index of the video stream to read. If the value is -1, the most suitable video stream will be automatically selected. The default value is "-1".

It allows overlaying a second video on top of the main input of a filtergraph, as shown in this graph:

    input -----------> deltapts0 --> overlay --> output
                                        ^
                                        |
    movie --> scale--> deltapts1 -------+

Some examples:

    # Skip 3.2 seconds from the start of the AVI file in.avi, and overlay it
    # on top of the input labelled "in"
    movie=in.avi:seek_point=3.2, scale=180:-1, setpts=PTS-STARTPTS [movie];
    [in] setpts=PTS-STARTPTS, [movie] overlay=16:16 [out]

    # Read from a video4linux2 device, and overlay it on top of the input
    # labelled "in"
    movie=/dev/video0:f=video4linux2, scale=180:-1, setpts=PTS-STARTPTS [movie];
    [in] setpts=PTS-STARTPTS, [movie] overlay=16:16 [out]

## 9.4 nullsrc

Null video source: never return images. It is mainly useful as a template and to be employed in analysis / debugging tools.

It accepts a string of the form width:height:timebase as an optional parameter.

width and height specify the size of the configured source. The default values of width and height are respectively 352 and 288 (corresponding to the CIF size format).

timebase specifies an arithmetic expression representing a timebase. The expression can contain the constants "PI", "E", "PHI", and "AVTB" (the default timebase), and defaults to the value "AVTB".

## 9.5 frei0r_src

Provide a frei0r source.

To enable compilation of this filter you need to install the frei0r header and configure Libav with -enable-frei0r.

This source accepts the following parameters:

``size'`

  The size of the video to generate. It may be a string of the form widthxheight or a frame size abbreviation.

``framerate'`

  The framerate of the generated video. It may be a string of the form num/den or a frame rate abbreviation.

``filter_name'`

  The name to the frei0r source to load. For more information regarding frei0r and how to set the parameters, read the frei0r section in the video filters documentation.

``filter_params'`

  A '|'-separated list of parameters to pass to the frei0r source.

An example:

    # Generate a frei0r partik0l source with size 200x200 and framerate 10
    # which is overlayed on the overlay filter main input
    frei0r_src=size=200x200:framerate=10:filter_name=partik0l:filter_params=1234 [overlay]; [in][overlay] overlay

## 9.6 rgbtestsrc, testsrc

The `rgbtestsrc` source generates an RGB test pattern useful for detecting RGB vs BGR issues. You should see a red, green and blue stripe from top to bottom.

The `testsrc` source generates a test video pattern, showing a color pattern, a scrolling gradient and a timestamp. This is mainly intended for testing purposes.

The sources accept the following parameters:

``size, s'`

  Specify the size of the sourced video, it may be a string of the form widthxheight, or the name of a size abbreviation. The default value is "320x240".

``rate, r'`

  Specify the frame rate of the sourced video, as the number of frames generated per second. It has to be a string in the format frame_rate_num/frame_rate_den, an integer number, a floating point number or a valid video frame rate abbreviation. The default value is "25".

``sar'`

  Set the sample aspect ratio of the sourced video.

``duration'`

  Set the video duration of the sourced video. The accepted syntax is:

      [-]HH[:MM[:SS[.m...]]]
      [-]S+[.m...]

  Also see the the `av_parse_time()` function.

  If not specified, or the expressed duration is negative, the video is supposed to be generated forever.

For example the following:

    testsrc=duration=5.3:size=qcif:rate=10

will generate a video with a duration of 5.3 seconds, with size 176x144 and a framerate of 10 frames per second.

# 10. Video Sinks

Below is a description of the currently available video sinks.

## 10.1 buffersink

Buffer video frames, and make them available to the end of the filter graph.

This sink is intended for programmatic use through the interface defined in ``libavfilter/buffersink.h'`.

## 10.2 nullsink

Null video sink: do absolutely nothing with the input video. It is mainly useful as a template and for use in analysis / debugging tools.

[Top] | [Contents] | [Index] | [ ? ]

# Table of Contents

[Top] | [Contents] | [Index] | [ ? ]

# About This Document

This document was generated on June, 28 2015 using texi2html 1.76.

The buttons in the navigation panels have the following meaning:

Button | Name | Go to | From 1.2.3 go to
--- | --- | --- | ---
[ < ] | Back | previous section in reading order | 1.2.2
[ > ] | Forward | next section in reading order | 1.2.4
[ << ] | FastBack | beginning of this chapter or previous chapter | 1
[ Up ] | Up | up section | 1.2
[ >> ] | FastForward | next chapter | 2
[Top] | Top | cover (top) of document |
[Contents] | Contents | table of contents |
[Index] | Index | index |
[ ? ] | About | about (help) |

where the Example assumes that the current position is at Subsubsection One-Two-Three of a document of the following structure:

- 1. Section One
  - 1.1 Subsection One-One
    - ...
  - 1.2 Subsection One-Two
    - 1.2.1 Subsubsection One-Two-One
    - 1.2.2 Subsubsection One-Two-Two
    - 1.2.3 Subsubsection One-Two-Three <== Current Position
    - 1.2.4 Subsubsection One-Two-Four
  - 1.3 Subsection One-Three
    - ...
  - 1.4 Subsection One-Four